#ifndef _H_0F682B7A68667052477D745FF5075F5B_RadarErrorStatus__H_
#define _H_0F682B7A68667052477D745FF5075F5B_RadarErrorStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace radar_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  RadarErrorStatus_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean comm_error_;
                ::DDS::Boolean overheat_error_;
                ::DDS::Boolean range_perf_error_;
                ::DDS::Boolean internal_error_;
                ::DDS::Boolean xcvr_operational_;
            };

            typedef DDS_DCPSStruct_var<RadarErrorStatus_> RadarErrorStatus__var;
            typedef DDS_DCPSStruct_out < RadarErrorStatus_> RadarErrorStatus__out;

        }

    }

}

#endif /* _H_0F682B7A68667052477D745FF5075F5B_RadarErrorStatus__H_ */
