#ifndef _H_0F682B7A68667052477D745FF5075F5B_RadarErrorStatus_DCPS_H_
#define _H_0F682B7A68667052477D745FF5075F5B_RadarErrorStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RadarErrorStatus_.h"


namespace radar_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RadarErrorStatus_TypeSupportInterface;

            typedef RadarErrorStatus_TypeSupportInterface * RadarErrorStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RadarErrorStatus_TypeSupportInterface> RadarErrorStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RadarErrorStatus_TypeSupportInterface> RadarErrorStatus_TypeSupportInterface_out;


            class RadarErrorStatus_DataWriter;

            typedef RadarErrorStatus_DataWriter * RadarErrorStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RadarErrorStatus_DataWriter> RadarErrorStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < RadarErrorStatus_DataWriter> RadarErrorStatus_DataWriter_out;


            class RadarErrorStatus_DataReader;

            typedef RadarErrorStatus_DataReader * RadarErrorStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RadarErrorStatus_DataReader> RadarErrorStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < RadarErrorStatus_DataReader> RadarErrorStatus_DataReader_out;


            class RadarErrorStatus_DataReaderView;

            typedef RadarErrorStatus_DataReaderView * RadarErrorStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RadarErrorStatus_DataReaderView> RadarErrorStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RadarErrorStatus_DataReaderView> RadarErrorStatus_DataReaderView_out;

            struct RadarErrorStatus_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RadarErrorStatus_, struct RadarErrorStatus_Seq_uniq_> RadarErrorStatus_Seq;
            typedef DDS_DCPSSequence_var < RadarErrorStatus_Seq> RadarErrorStatus_Seq_var;
            typedef DDS_DCPSSequence_out < RadarErrorStatus_Seq> RadarErrorStatus_Seq_out;

            class  RadarErrorStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RadarErrorStatus_TypeSupportInterface_ptr _ptr_type;
                typedef RadarErrorStatus_TypeSupportInterface_var _var_type;

                static RadarErrorStatus_TypeSupportInterface_ptr _duplicate (RadarErrorStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarErrorStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RadarErrorStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarErrorStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarErrorStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RadarErrorStatus_TypeSupportInterface () {};
                ~RadarErrorStatus_TypeSupportInterface () {};
            private:
                RadarErrorStatus_TypeSupportInterface (const RadarErrorStatus_TypeSupportInterface &);
                RadarErrorStatus_TypeSupportInterface & operator = (const RadarErrorStatus_TypeSupportInterface &);
            };

            class  RadarErrorStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RadarErrorStatus_DataWriter_ptr _ptr_type;
                typedef RadarErrorStatus_DataWriter_var _var_type;

                static RadarErrorStatus_DataWriter_ptr _duplicate (RadarErrorStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarErrorStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RadarErrorStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarErrorStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarErrorStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RadarErrorStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RadarErrorStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RadarErrorStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RadarErrorStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RadarErrorStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RadarErrorStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RadarErrorStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RadarErrorStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RadarErrorStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RadarErrorStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RadarErrorStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarErrorStatus_& instance_data) = 0;

            protected:
                RadarErrorStatus_DataWriter () {};
                ~RadarErrorStatus_DataWriter () {};
            private:
                RadarErrorStatus_DataWriter (const RadarErrorStatus_DataWriter &);
                RadarErrorStatus_DataWriter & operator = (const RadarErrorStatus_DataWriter &);
            };

            class  RadarErrorStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RadarErrorStatus_DataReader_ptr _ptr_type;
                typedef RadarErrorStatus_DataReader_var _var_type;

                static RadarErrorStatus_DataReader_ptr _duplicate (RadarErrorStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarErrorStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RadarErrorStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarErrorStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarErrorStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadarErrorStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadarErrorStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadarErrorStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarErrorStatus_& instance) = 0;

            protected:
                RadarErrorStatus_DataReader () {};
                ~RadarErrorStatus_DataReader () {};
            private:
                RadarErrorStatus_DataReader (const RadarErrorStatus_DataReader &);
                RadarErrorStatus_DataReader & operator = (const RadarErrorStatus_DataReader &);
            };

            class  RadarErrorStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RadarErrorStatus_DataReaderView_ptr _ptr_type;
                typedef RadarErrorStatus_DataReaderView_var _var_type;

                static RadarErrorStatus_DataReaderView_ptr _duplicate (RadarErrorStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarErrorStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RadarErrorStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarErrorStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarErrorStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadarErrorStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadarErrorStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadarErrorStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadarErrorStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarErrorStatus_& instance) = 0;

            protected:
                RadarErrorStatus_DataReaderView () {};
                ~RadarErrorStatus_DataReaderView () {};
            private:
                RadarErrorStatus_DataReaderView (const RadarErrorStatus_DataReaderView &);
                RadarErrorStatus_DataReaderView & operator = (const RadarErrorStatus_DataReaderView &);
            };
        }

    }

}

#endif
