#ifndef _H_E846B2E1950692BB02484BF73CBA3508_RadarStatus__H_
#define _H_E846B2E1950692BB02484BF73CBA3508_RadarStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace radar_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  RadarStatus_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Short curvature_;
                ::DDS::Float yaw_rate_;
                ::DDS::Float vehicle_speed_;
                ::DDS::Octet max_track_targets_;
                ::DDS::Boolean raw_data_mode_;
                ::DDS::Octet temperature_;
                ::DDS::Boolean patial_blockage_;
                ::DDS::Boolean side_lobe_blockage_;
            };

            typedef DDS_DCPSStruct_var<RadarStatus_> RadarStatus__var;
            typedef DDS_DCPSStruct_out < RadarStatus_> RadarStatus__out;

        }

    }

}

#endif /* _H_E846B2E1950692BB02484BF73CBA3508_RadarStatus__H_ */
