#ifndef _H_8132C8E551BB44E872C3E1F52EA9BCDB_RadarTrackArray_DCPS_H_
#define _H_8132C8E551BB44E872C3E1F52EA9BCDB_RadarTrackArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RadarTrackArray_.h"


namespace radar_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RadarTrackArray_TypeSupportInterface;

            typedef RadarTrackArray_TypeSupportInterface * RadarTrackArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RadarTrackArray_TypeSupportInterface> RadarTrackArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RadarTrackArray_TypeSupportInterface> RadarTrackArray_TypeSupportInterface_out;


            class RadarTrackArray_DataWriter;

            typedef RadarTrackArray_DataWriter * RadarTrackArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RadarTrackArray_DataWriter> RadarTrackArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < RadarTrackArray_DataWriter> RadarTrackArray_DataWriter_out;


            class RadarTrackArray_DataReader;

            typedef RadarTrackArray_DataReader * RadarTrackArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RadarTrackArray_DataReader> RadarTrackArray_DataReader_var;
            typedef DDS_DCPSInterface_out < RadarTrackArray_DataReader> RadarTrackArray_DataReader_out;


            class RadarTrackArray_DataReaderView;

            typedef RadarTrackArray_DataReaderView * RadarTrackArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RadarTrackArray_DataReaderView> RadarTrackArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RadarTrackArray_DataReaderView> RadarTrackArray_DataReaderView_out;

            struct RadarTrackArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RadarTrackArray_, struct RadarTrackArray_Seq_uniq_> RadarTrackArray_Seq;
            typedef DDS_DCPSSequence_var < RadarTrackArray_Seq> RadarTrackArray_Seq_var;
            typedef DDS_DCPSSequence_out < RadarTrackArray_Seq> RadarTrackArray_Seq_out;

            class  RadarTrackArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RadarTrackArray_TypeSupportInterface_ptr _ptr_type;
                typedef RadarTrackArray_TypeSupportInterface_var _var_type;

                static RadarTrackArray_TypeSupportInterface_ptr _duplicate (RadarTrackArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarTrackArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RadarTrackArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarTrackArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarTrackArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RadarTrackArray_TypeSupportInterface () {};
                ~RadarTrackArray_TypeSupportInterface () {};
            private:
                RadarTrackArray_TypeSupportInterface (const RadarTrackArray_TypeSupportInterface &);
                RadarTrackArray_TypeSupportInterface & operator = (const RadarTrackArray_TypeSupportInterface &);
            };

            class  RadarTrackArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RadarTrackArray_DataWriter_ptr _ptr_type;
                typedef RadarTrackArray_DataWriter_var _var_type;

                static RadarTrackArray_DataWriter_ptr _duplicate (RadarTrackArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarTrackArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RadarTrackArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarTrackArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarTrackArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RadarTrackArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RadarTrackArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RadarTrackArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RadarTrackArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RadarTrackArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RadarTrackArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RadarTrackArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RadarTrackArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RadarTrackArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RadarTrackArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RadarTrackArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarTrackArray_& instance_data) = 0;

            protected:
                RadarTrackArray_DataWriter () {};
                ~RadarTrackArray_DataWriter () {};
            private:
                RadarTrackArray_DataWriter (const RadarTrackArray_DataWriter &);
                RadarTrackArray_DataWriter & operator = (const RadarTrackArray_DataWriter &);
            };

            class  RadarTrackArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RadarTrackArray_DataReader_ptr _ptr_type;
                typedef RadarTrackArray_DataReader_var _var_type;

                static RadarTrackArray_DataReader_ptr _duplicate (RadarTrackArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarTrackArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RadarTrackArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarTrackArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarTrackArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadarTrackArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadarTrackArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadarTrackArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarTrackArray_& instance) = 0;

            protected:
                RadarTrackArray_DataReader () {};
                ~RadarTrackArray_DataReader () {};
            private:
                RadarTrackArray_DataReader (const RadarTrackArray_DataReader &);
                RadarTrackArray_DataReader & operator = (const RadarTrackArray_DataReader &);
            };

            class  RadarTrackArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RadarTrackArray_DataReaderView_ptr _ptr_type;
                typedef RadarTrackArray_DataReaderView_var _var_type;

                static RadarTrackArray_DataReaderView_ptr _duplicate (RadarTrackArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarTrackArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RadarTrackArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarTrackArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarTrackArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadarTrackArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadarTrackArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadarTrackArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadarTrackArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarTrackArray_& instance) = 0;

            protected:
                RadarTrackArray_DataReaderView () {};
                ~RadarTrackArray_DataReaderView () {};
            private:
                RadarTrackArray_DataReaderView (const RadarTrackArray_DataReaderView &);
                RadarTrackArray_DataReaderView & operator = (const RadarTrackArray_DataReaderView &);
            };
        }

    }

}

#endif
