#ifndef H_C685F10AE261F38BA4BEC4B970739D01_RadarTrack_SPLTYPES_H
#define H_C685F10AE261F38BA4BEC4B970739D01_RadarTrack_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_RadarTrack_.h"
#include "geometry_msgs/msg/dds_opensplice/Polygon_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Vector3_SplDcps.h"



extern c_metaObject __RadarTrack__radar_msgs__load (c_base base);

extern c_metaObject __RadarTrack__radar_msgs_msg__load (c_base base);

extern c_metaObject __RadarTrack__radar_msgs_msg_dds___load (c_base base);

extern const char *radar_msgs_msg_dds__RadarTrack__metaDescriptor[];
extern const int radar_msgs_msg_dds__RadarTrack__metaDescriptorArrLength;
extern const int radar_msgs_msg_dds__RadarTrack__metaDescriptorLength;
extern c_metaObject __radar_msgs_msg_dds__RadarTrack___load (c_base base);
struct _radar_msgs_msg_dds__RadarTrack_ ;
extern  v_copyin_result __radar_msgs_msg_dds__RadarTrack___copyIn(c_base base, const struct radar_msgs::msg::dds_::RadarTrack_ *from, struct _radar_msgs_msg_dds__RadarTrack_ *to);
extern  void __radar_msgs_msg_dds__RadarTrack___copyOut(const void *_from, void *_to);
struct _radar_msgs_msg_dds__RadarTrack_ {
    c_ushort track_id_;
    struct _geometry_msgs_msg_dds__Polygon_ track_shape_;
    struct _geometry_msgs_msg_dds__Vector3_ linear_velocity_;
    struct _geometry_msgs_msg_dds__Vector3_ linear_acceleration_;
};

#undef OS_API
#endif
