// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from radar_msgs:msg/RadarDetection.idl
// generated code does not contain a copyright notice

#ifndef RADAR_MSGS__MSG__RADAR_DETECTION__FUNCTIONS_H_
#define RADAR_MSGS__MSG__RADAR_DETECTION__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "radar_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "radar_msgs/msg/radar_detection__struct.h"

/// Initialize msg/RadarDetection message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * radar_msgs__msg__RadarDetection
 * )) before or use
 * radar_msgs__msg__RadarDetection__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_radar_msgs
bool
radar_msgs__msg__RadarDetection__init(radar_msgs__msg__RadarDetection * msg);

/// Finalize msg/RadarDetection message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_radar_msgs
void
radar_msgs__msg__RadarDetection__fini(radar_msgs__msg__RadarDetection * msg);

/// Create msg/RadarDetection message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * radar_msgs__msg__RadarDetection__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_radar_msgs
radar_msgs__msg__RadarDetection *
radar_msgs__msg__RadarDetection__create();

/// Destroy msg/RadarDetection message.
/**
 * It calls
 * radar_msgs__msg__RadarDetection__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_radar_msgs
void
radar_msgs__msg__RadarDetection__destroy(radar_msgs__msg__RadarDetection * msg);


/// Initialize array of msg/RadarDetection messages.
/**
 * It allocates the memory for the number of elements and calls
 * radar_msgs__msg__RadarDetection__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_radar_msgs
bool
radar_msgs__msg__RadarDetection__Sequence__init(radar_msgs__msg__RadarDetection__Sequence * array, size_t size);

/// Finalize array of msg/RadarDetection messages.
/**
 * It calls
 * radar_msgs__msg__RadarDetection__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_radar_msgs
void
radar_msgs__msg__RadarDetection__Sequence__fini(radar_msgs__msg__RadarDetection__Sequence * array);

/// Create array of msg/RadarDetection messages.
/**
 * It allocates the memory for the array and calls
 * radar_msgs__msg__RadarDetection__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_radar_msgs
radar_msgs__msg__RadarDetection__Sequence *
radar_msgs__msg__RadarDetection__Sequence__create(size_t size);

/// Destroy array of msg/RadarDetection messages.
/**
 * It calls
 * radar_msgs__msg__RadarDetection__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_radar_msgs
void
radar_msgs__msg__RadarDetection__Sequence__destroy(radar_msgs__msg__RadarDetection__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // RADAR_MSGS__MSG__RADAR_DETECTION__FUNCTIONS_H_
