// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from radar_msgs:msg/RadarTrack.idl
// generated code does not contain a copyright notice

#ifndef RADAR_MSGS__MSG__RADAR_TRACK__STRUCT_HPP_
#define RADAR_MSGS__MSG__RADAR_TRACK__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'track_shape'
#include "geometry_msgs/msg/polygon__struct.hpp"
// Member 'linear_velocity'
// Member 'linear_acceleration'
#include "geometry_msgs/msg/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__radar_msgs__msg__RadarTrack __attribute__((deprecated))
#else
# define DEPRECATED__radar_msgs__msg__RadarTrack __declspec(deprecated)
#endif

namespace radar_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RadarTrack_
{
  using Type = RadarTrack_<ContainerAllocator>;

  explicit RadarTrack_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : track_shape(_init),
    linear_velocity(_init),
    linear_acceleration(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->track_id = 0;
    }
  }

  explicit RadarTrack_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : track_shape(_alloc, _init),
    linear_velocity(_alloc, _init),
    linear_acceleration(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->track_id = 0;
    }
  }

  // field types and members
  using _track_id_type =
    uint16_t;
  _track_id_type track_id;
  using _track_shape_type =
    geometry_msgs::msg::Polygon_<ContainerAllocator>;
  _track_shape_type track_shape;
  using _linear_velocity_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _linear_velocity_type linear_velocity;
  using _linear_acceleration_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _linear_acceleration_type linear_acceleration;

  // setters for named parameter idiom
  Type & set__track_id(
    const uint16_t & _arg)
  {
    this->track_id = _arg;
    return *this;
  }
  Type & set__track_shape(
    const geometry_msgs::msg::Polygon_<ContainerAllocator> & _arg)
  {
    this->track_shape = _arg;
    return *this;
  }
  Type & set__linear_velocity(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->linear_velocity = _arg;
    return *this;
  }
  Type & set__linear_acceleration(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->linear_acceleration = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    radar_msgs::msg::RadarTrack_<ContainerAllocator> *;
  using ConstRawPtr =
    const radar_msgs::msg::RadarTrack_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<radar_msgs::msg::RadarTrack_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<radar_msgs::msg::RadarTrack_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      radar_msgs::msg::RadarTrack_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<radar_msgs::msg::RadarTrack_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      radar_msgs::msg::RadarTrack_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<radar_msgs::msg::RadarTrack_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<radar_msgs::msg::RadarTrack_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<radar_msgs::msg::RadarTrack_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__radar_msgs__msg__RadarTrack
    std::shared_ptr<radar_msgs::msg::RadarTrack_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__radar_msgs__msg__RadarTrack
    std::shared_ptr<radar_msgs::msg::RadarTrack_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RadarTrack_ & other) const
  {
    if (this->track_id != other.track_id) {
      return false;
    }
    if (this->track_shape != other.track_shape) {
      return false;
    }
    if (this->linear_velocity != other.linear_velocity) {
      return false;
    }
    if (this->linear_acceleration != other.linear_acceleration) {
      return false;
    }
    return true;
  }
  bool operator!=(const RadarTrack_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RadarTrack_

// alias to use template instance with default allocator
using RadarTrack =
  radar_msgs::msg::RadarTrack_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace radar_msgs

#endif  // RADAR_MSGS__MSG__RADAR_TRACK__STRUCT_HPP_
