#ifndef _H_6F3337724CAB7094F71724E947C51A25_RadarDetectionArray_DCPS_H_
#define _H_6F3337724CAB7094F71724E947C51A25_RadarDetectionArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RadarDetectionArray_.h"


namespace radar_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RadarDetectionArray_TypeSupportInterface;

            typedef RadarDetectionArray_TypeSupportInterface * RadarDetectionArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RadarDetectionArray_TypeSupportInterface> RadarDetectionArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RadarDetectionArray_TypeSupportInterface> RadarDetectionArray_TypeSupportInterface_out;


            class RadarDetectionArray_DataWriter;

            typedef RadarDetectionArray_DataWriter * RadarDetectionArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RadarDetectionArray_DataWriter> RadarDetectionArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < RadarDetectionArray_DataWriter> RadarDetectionArray_DataWriter_out;


            class RadarDetectionArray_DataReader;

            typedef RadarDetectionArray_DataReader * RadarDetectionArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RadarDetectionArray_DataReader> RadarDetectionArray_DataReader_var;
            typedef DDS_DCPSInterface_out < RadarDetectionArray_DataReader> RadarDetectionArray_DataReader_out;


            class RadarDetectionArray_DataReaderView;

            typedef RadarDetectionArray_DataReaderView * RadarDetectionArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RadarDetectionArray_DataReaderView> RadarDetectionArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RadarDetectionArray_DataReaderView> RadarDetectionArray_DataReaderView_out;

            struct RadarDetectionArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RadarDetectionArray_, struct RadarDetectionArray_Seq_uniq_> RadarDetectionArray_Seq;
            typedef DDS_DCPSSequence_var < RadarDetectionArray_Seq> RadarDetectionArray_Seq_var;
            typedef DDS_DCPSSequence_out < RadarDetectionArray_Seq> RadarDetectionArray_Seq_out;

            class  RadarDetectionArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RadarDetectionArray_TypeSupportInterface_ptr _ptr_type;
                typedef RadarDetectionArray_TypeSupportInterface_var _var_type;

                static RadarDetectionArray_TypeSupportInterface_ptr _duplicate (RadarDetectionArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarDetectionArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RadarDetectionArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarDetectionArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarDetectionArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RadarDetectionArray_TypeSupportInterface () {};
                ~RadarDetectionArray_TypeSupportInterface () {};
            private:
                RadarDetectionArray_TypeSupportInterface (const RadarDetectionArray_TypeSupportInterface &);
                RadarDetectionArray_TypeSupportInterface & operator = (const RadarDetectionArray_TypeSupportInterface &);
            };

            class  RadarDetectionArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RadarDetectionArray_DataWriter_ptr _ptr_type;
                typedef RadarDetectionArray_DataWriter_var _var_type;

                static RadarDetectionArray_DataWriter_ptr _duplicate (RadarDetectionArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarDetectionArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RadarDetectionArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarDetectionArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarDetectionArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RadarDetectionArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RadarDetectionArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RadarDetectionArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RadarDetectionArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RadarDetectionArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RadarDetectionArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RadarDetectionArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RadarDetectionArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RadarDetectionArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RadarDetectionArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RadarDetectionArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarDetectionArray_& instance_data) = 0;

            protected:
                RadarDetectionArray_DataWriter () {};
                ~RadarDetectionArray_DataWriter () {};
            private:
                RadarDetectionArray_DataWriter (const RadarDetectionArray_DataWriter &);
                RadarDetectionArray_DataWriter & operator = (const RadarDetectionArray_DataWriter &);
            };

            class  RadarDetectionArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RadarDetectionArray_DataReader_ptr _ptr_type;
                typedef RadarDetectionArray_DataReader_var _var_type;

                static RadarDetectionArray_DataReader_ptr _duplicate (RadarDetectionArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarDetectionArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RadarDetectionArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarDetectionArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarDetectionArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadarDetectionArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadarDetectionArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadarDetectionArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarDetectionArray_& instance) = 0;

            protected:
                RadarDetectionArray_DataReader () {};
                ~RadarDetectionArray_DataReader () {};
            private:
                RadarDetectionArray_DataReader (const RadarDetectionArray_DataReader &);
                RadarDetectionArray_DataReader & operator = (const RadarDetectionArray_DataReader &);
            };

            class  RadarDetectionArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RadarDetectionArray_DataReaderView_ptr _ptr_type;
                typedef RadarDetectionArray_DataReaderView_var _var_type;

                static RadarDetectionArray_DataReaderView_ptr _duplicate (RadarDetectionArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarDetectionArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RadarDetectionArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarDetectionArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarDetectionArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadarDetectionArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadarDetectionArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadarDetectionArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadarDetectionArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarDetectionArray_& instance) = 0;

            protected:
                RadarDetectionArray_DataReaderView () {};
                ~RadarDetectionArray_DataReaderView () {};
            private:
                RadarDetectionArray_DataReaderView (const RadarDetectionArray_DataReaderView &);
                RadarDetectionArray_DataReaderView & operator = (const RadarDetectionArray_DataReaderView &);
            };
        }

    }

}

#endif
