#ifndef _H_8B0665376E968EC1A48ECFCB6C6C23A8_RadarDetectionStamped_DCPS_H_
#define _H_8B0665376E968EC1A48ECFCB6C6C23A8_RadarDetectionStamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RadarDetectionStamped_.h"


namespace radar_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RadarDetectionStamped_TypeSupportInterface;

            typedef RadarDetectionStamped_TypeSupportInterface * RadarDetectionStamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RadarDetectionStamped_TypeSupportInterface> RadarDetectionStamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RadarDetectionStamped_TypeSupportInterface> RadarDetectionStamped_TypeSupportInterface_out;


            class RadarDetectionStamped_DataWriter;

            typedef RadarDetectionStamped_DataWriter * RadarDetectionStamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RadarDetectionStamped_DataWriter> RadarDetectionStamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < RadarDetectionStamped_DataWriter> RadarDetectionStamped_DataWriter_out;


            class RadarDetectionStamped_DataReader;

            typedef RadarDetectionStamped_DataReader * RadarDetectionStamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RadarDetectionStamped_DataReader> RadarDetectionStamped_DataReader_var;
            typedef DDS_DCPSInterface_out < RadarDetectionStamped_DataReader> RadarDetectionStamped_DataReader_out;


            class RadarDetectionStamped_DataReaderView;

            typedef RadarDetectionStamped_DataReaderView * RadarDetectionStamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RadarDetectionStamped_DataReaderView> RadarDetectionStamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RadarDetectionStamped_DataReaderView> RadarDetectionStamped_DataReaderView_out;

            struct RadarDetectionStamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RadarDetectionStamped_, struct RadarDetectionStamped_Seq_uniq_> RadarDetectionStamped_Seq;
            typedef DDS_DCPSSequence_var < RadarDetectionStamped_Seq> RadarDetectionStamped_Seq_var;
            typedef DDS_DCPSSequence_out < RadarDetectionStamped_Seq> RadarDetectionStamped_Seq_out;

            class  RadarDetectionStamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RadarDetectionStamped_TypeSupportInterface_ptr _ptr_type;
                typedef RadarDetectionStamped_TypeSupportInterface_var _var_type;

                static RadarDetectionStamped_TypeSupportInterface_ptr _duplicate (RadarDetectionStamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarDetectionStamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RadarDetectionStamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarDetectionStamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarDetectionStamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RadarDetectionStamped_TypeSupportInterface () {};
                ~RadarDetectionStamped_TypeSupportInterface () {};
            private:
                RadarDetectionStamped_TypeSupportInterface (const RadarDetectionStamped_TypeSupportInterface &);
                RadarDetectionStamped_TypeSupportInterface & operator = (const RadarDetectionStamped_TypeSupportInterface &);
            };

            class  RadarDetectionStamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RadarDetectionStamped_DataWriter_ptr _ptr_type;
                typedef RadarDetectionStamped_DataWriter_var _var_type;

                static RadarDetectionStamped_DataWriter_ptr _duplicate (RadarDetectionStamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarDetectionStamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RadarDetectionStamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarDetectionStamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarDetectionStamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RadarDetectionStamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RadarDetectionStamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RadarDetectionStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RadarDetectionStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RadarDetectionStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RadarDetectionStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RadarDetectionStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RadarDetectionStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RadarDetectionStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RadarDetectionStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RadarDetectionStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarDetectionStamped_& instance_data) = 0;

            protected:
                RadarDetectionStamped_DataWriter () {};
                ~RadarDetectionStamped_DataWriter () {};
            private:
                RadarDetectionStamped_DataWriter (const RadarDetectionStamped_DataWriter &);
                RadarDetectionStamped_DataWriter & operator = (const RadarDetectionStamped_DataWriter &);
            };

            class  RadarDetectionStamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RadarDetectionStamped_DataReader_ptr _ptr_type;
                typedef RadarDetectionStamped_DataReader_var _var_type;

                static RadarDetectionStamped_DataReader_ptr _duplicate (RadarDetectionStamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarDetectionStamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RadarDetectionStamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarDetectionStamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarDetectionStamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadarDetectionStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadarDetectionStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadarDetectionStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarDetectionStamped_& instance) = 0;

            protected:
                RadarDetectionStamped_DataReader () {};
                ~RadarDetectionStamped_DataReader () {};
            private:
                RadarDetectionStamped_DataReader (const RadarDetectionStamped_DataReader &);
                RadarDetectionStamped_DataReader & operator = (const RadarDetectionStamped_DataReader &);
            };

            class  RadarDetectionStamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RadarDetectionStamped_DataReaderView_ptr _ptr_type;
                typedef RadarDetectionStamped_DataReaderView_var _var_type;

                static RadarDetectionStamped_DataReaderView_ptr _duplicate (RadarDetectionStamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RadarDetectionStamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RadarDetectionStamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RadarDetectionStamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RadarDetectionStamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RadarDetectionStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RadarDetectionStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RadarDetectionStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RadarDetectionStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RadarDetectionStamped_& instance) = 0;

            protected:
                RadarDetectionStamped_DataReaderView () {};
                ~RadarDetectionStamped_DataReaderView () {};
            private:
                RadarDetectionStamped_DataReaderView (const RadarDetectionStamped_DataReaderView &);
                RadarDetectionStamped_DataReaderView & operator = (const RadarDetectionStamped_DataReaderView &);
            };
        }

    }

}

#endif
