// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from radar_msgs:msg/RadarStatus.idl
// generated code does not contain a copyright notice
#include "radar_msgs/msg/radar_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"

bool
radar_msgs__msg__RadarStatus__init(radar_msgs__msg__RadarStatus * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    radar_msgs__msg__RadarStatus__destroy(msg);
    return false;
  }
  // curvature
  // yaw_rate
  // vehicle_speed
  // max_track_targets
  // raw_data_mode
  // temperature
  // patial_blockage
  // side_lobe_blockage
  return true;
}

void
radar_msgs__msg__RadarStatus__fini(radar_msgs__msg__RadarStatus * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // curvature
  // yaw_rate
  // vehicle_speed
  // max_track_targets
  // raw_data_mode
  // temperature
  // patial_blockage
  // side_lobe_blockage
}

radar_msgs__msg__RadarStatus *
radar_msgs__msg__RadarStatus__create()
{
  radar_msgs__msg__RadarStatus * msg = (radar_msgs__msg__RadarStatus *)malloc(sizeof(radar_msgs__msg__RadarStatus));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(radar_msgs__msg__RadarStatus));
  bool success = radar_msgs__msg__RadarStatus__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
radar_msgs__msg__RadarStatus__destroy(radar_msgs__msg__RadarStatus * msg)
{
  if (msg) {
    radar_msgs__msg__RadarStatus__fini(msg);
  }
  free(msg);
}


bool
radar_msgs__msg__RadarStatus__Sequence__init(radar_msgs__msg__RadarStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  radar_msgs__msg__RadarStatus * data = NULL;
  if (size) {
    data = (radar_msgs__msg__RadarStatus *)calloc(size, sizeof(radar_msgs__msg__RadarStatus));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = radar_msgs__msg__RadarStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        radar_msgs__msg__RadarStatus__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
radar_msgs__msg__RadarStatus__Sequence__fini(radar_msgs__msg__RadarStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      radar_msgs__msg__RadarStatus__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

radar_msgs__msg__RadarStatus__Sequence *
radar_msgs__msg__RadarStatus__Sequence__create(size_t size)
{
  radar_msgs__msg__RadarStatus__Sequence * array = (radar_msgs__msg__RadarStatus__Sequence *)malloc(sizeof(radar_msgs__msg__RadarStatus__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = radar_msgs__msg__RadarStatus__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
radar_msgs__msg__RadarStatus__Sequence__destroy(radar_msgs__msg__RadarStatus__Sequence * array)
{
  if (array) {
    radar_msgs__msg__RadarStatus__Sequence__fini(array);
  }
  free(array);
}
